﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using PartyServices.Domain.Contexts;

#nullable disable

namespace PartyServices.Domain.Migrations
{
    [DbContext(typeof(PartyServicesContext))]
    [Migration("20241010095913_AddedAddresses")]
    partial class AddedAddresses
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "8.0.0")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Address", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("City")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("city");

                    b.Property<string>("HouseNumber")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("house_number");

                    b.Property<string>("PostalCode")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("postal_code");

                    b.Property<string>("Street")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("street");

                    b.HasKey("Uuid");

                    b.ToTable("addresses");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Department", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.Property<Guid>("OrganisationUuid")
                        .HasColumnType("uuid")
                        .HasColumnName("organisation_uuid");

                    b.Property<string>("PostadressenIds")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("postadressen_ids");

                    b.Property<string>("RekeningenIds")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("rekeningen_ids");

                    b.HasKey("Uuid");

                    b.HasIndex("OrganisationUuid");

                    b.ToTable("departments");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.DepartmentAddress", b =>
                {
                    b.Property<Guid>("DepartmentUuid")
                        .HasColumnType("uuid")
                        .HasColumnName("department_uuid");

                    b.Property<Guid>("AddressUuid")
                        .HasColumnType("uuid")
                        .HasColumnName("address_uuid");

                    b.HasKey("DepartmentUuid", "AddressUuid");

                    b.HasIndex("AddressUuid")
                        .IsUnique();

                    b.ToTable("department_addresses");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Organisation", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("BranchNumber")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("branch_number");

                    b.Property<string>("KvkNumber")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("kvk_number");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.HasKey("Uuid");

                    b.ToTable("organisations");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Department", b =>
                {
                    b.HasOne("PartyServices.Domain.Contexts.Models.Organisation", "Organisation")
                        .WithMany("Departments")
                        .HasForeignKey("OrganisationUuid")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Organisation");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.DepartmentAddress", b =>
                {
                    b.HasOne("PartyServices.Domain.Contexts.Models.Address", "Address")
                        .WithMany("Department")
                        .HasForeignKey("AddressUuid")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("PartyServices.Domain.Contexts.Models.Department", "Department")
                        .WithMany("Addresses")
                        .HasForeignKey("DepartmentUuid")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Address");

                    b.Navigation("Department");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Address", b =>
                {
                    b.Navigation("Department");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Department", b =>
                {
                    b.Navigation("Addresses");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Organisation", b =>
                {
                    b.Navigation("Departments");
                });
#pragma warning restore 612, 618
        }
    }
}
